#! /bin/sed -f

/[^0-9]/ d

# Add position markers (a before units, b before tenths, ...)
s/.$/a&/
s/.a/b&/
s/.b/c&/
s/.c/d&/
s/.d/e&/
s/.e/f&/
s/.f/g&/
s/.g/h&/
s/^[0-9]*//

# Convert to analog
s/\([a-h]\)9/\1\1\1\1\1\1\1\1\1/g
s/\([a-h]\)8/\1\1\1\1\1\1\1\1/g
s/\([a-h]\)7/\1\1\1\1\1\1\1/g
s/\([a-h]\)6/\1\1\1\1\1\1/g
s/\([a-h]\)5/\1\1\1\1\1/g
s/\([a-h]\)4/\1\1\1\1/g
s/\([a-h]\)3/\1\1\1/g
s/\([a-h]\)2/\1\1/g
s/\([a-h]\)1/\1/g
s/\([a-h]\)0//g

# Get the total in pattern space
H
g
s/\n//g

# Group homogeneous letters together
s/\(a*\)\([^a]*\)\(a*\)$/\1\3\2/p
s/\(b*\)\([^b]*\)\(b*\)$/\1\3\2/p
s/\(c*\)\([^c]*\)\(c*\)$/\1\3\2/p
s/\(d*\)\([^d]*\)\(d*\)$/\1\3\2/p
s/\(e*\)\([^e]*\)\(e*\)$/\1\3\2/p
s/\(f*\)\([^f]*\)\(f*\)$/\1\3\2/p
s/\(g*\)\([^g]*\)\(g*\)$/\1\3\2/p
s/\(h*\)\([^h]*\)\(h*\)$/\1\3\2/p

# Do the carry.
s/aaaaaaaaaa/b/g
s/bbbbbbbbbb/c/g
s/cccccccccc/d/g
s/dddddddddd/e/g
s/eeeeeeeeee/f/g
s/ffffffffff/g/g
s/gggggggggg/h/g
s/hhhhhhhhhh//g
h

# Convert back to decimal
: loop
/a/! s/[b-h]*/&0/
s/aaaaaaaaa/9/
s/aaaaaaaa/8/
s/aaaaaaa/7/
s/aaaaaa/6/
s/aaaaa/5/
s/aaaa/4/
s/aaa/3/
s/aa/2/
s/a/1/

: next
y/bcdefgh/abcdefg/
/[a-h]/ b loop
